<template>
  <transition :name="transition" :mode="transitionMode">
    <!--
      Loading
      Will be visible when the mutation is loading. This will be empty when the
      query is loading but "displayLoading" is false. (will be the case when
      using the "delayLoading" prop)
    -->
    <div v-if="mutation.loading.value" key="loading" :style="slotStyle">
      <slot v-show="displayLoading" name="loading" />
    </div>

    <!--
      Error
      Will be visible when the mutation resolved in an error
    -->
    <div v-else-if="error" key="error" :style="slotStyle">
      <slot name="error" />
    </div>

    <!--
      Success
      Will be visible when the mutation resolved in a success
    -->
    <div v-else-if="success" key="success" :style="slotStyle">
      <slot name="success" />
    </div>

    <!--
      Component
      Will be visible when no error, success or loading is present
    -->
    <div v-else ref="componentSlot" key="component">
      <slot name="component" />
    </div>
  </transition>
</template>

<script lang="ts">
import { computed, defineComponent, PropType, ref, watch } from '@nuxtjs/composition-api'
import { UseMutationReturn } from '@vue/apollo-composable'
import { useElementSize } from '@vueuse/core'

export default defineComponent({
  props: {
    // Mutation
    mutation: {
      type: Object as PropType<UseMutationReturn<any, any>>,
      required: true,
    },

    // Amount of milliseconds to wait until the error slot will be hidden
    // Error will remain visible, as long as the mutation is not called again otherwise.
    errorTimeout: {
      type: Number,
      default: 0,
    },

    // Amount of milliseconds to wait until the success slot will be hidden
    // Success will remain visible, as long as the mutation is not called again otherwise.
    successTimeout: {
      type: Number,
      default: 0,
    },

    // Delay loading
    // Will delay showing the loading animation until the specified time has passed
    // and will show a empty screen instead
    delayLoading: {
      type: Number as PropType<number>,
      default: 0,
    },

    // Transition between modes
    transition: {
      type: String as PropType<string>,
      default: '',
    },

    // Transition mode
    transitionMode: {
      type: String as PropType<string>,
      default: '',
    },

    // Force all slots to have the same size as the 'component' slot
    forceSize: {
      type: Boolean as PropType<boolean>,
      default: false,
    },
  },
  setup(props) {
    // If the error slot should be displayed
    const error = ref(false)

    // If the success slot should be displayed
    const success = ref(false)

    // Watch the mutation for a potential error
    props.mutation.onError(() => {
      // Display the error slot
      error.value = true

      // Hide the success slot after "successTimeout" millisecond
      if (props.errorTimeout > 0) {
        setTimeout(() => (error.value = false), props.errorTimeout)
      }
    })

    // Watch the mutation for a potential result
    props.mutation.onDone(() => {
      // Display the success slot
      success.value = true

      // Hide the success slot after "successTimeout" millisecond
      if (props.successTimeout > 0) {
        setTimeout(() => (success.value = false), props.successTimeout)
      }
    })

    // Hide success message when the mutation is loading again.
    // This indicates that the mutation is called again.
    watch(
      () => props.mutation.loading.value,
      (loading) => {
        if (loading) {
          // Hide the success slot
          success.value = false
        }
      }
    )

    // Should the loading slot be displayed
    const displayLoading = ref(false)

    // Watch the mutation
    // If the mutation switched loading to false, set a timeout to update the displayLoading
    watch(
      () => props.mutation.loading,
      (loading) => {
        if (loading) {
          setTimeout(() => (displayLoading.value = true), props.delayLoading)
        }
      },
      { immediate: true }
    )

    // Component slot ref binding
    const componentSlot = ref<HTMLElement>()
    const componentSlotSize = useElementSize(componentSlot)

    // Height and width styling for other slots when "forceSize" prop is true
    const slotStyle = computed(() => {
      // If the "forceSize" prop is false, return no extra styling
      if (!props.forceSize) {
        return ''
      }

      // Get the width and height of the "component" slot
      // Return a style string with the width and height
      return `width: ${componentSlotSize.width.value}px; height: ${componentSlotSize.height.value}px`
    })

    return {
      error,
      success,
      displayLoading,
      componentSlot,
      slotStyle,
    }
  },
})
</script>
